/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* 如果要在程序中使用此代码,请在程序中注明使用了STC的资料及程序            */
/*---------------------------------------------------------------------*/

#include	"STC32G_GPIO.h"
#include    "STC32G_Exti.h"
//========================================================================
// 函数: uint8_t	GPIO_Inilize(uint8_t GPIO, GPIO_InitTypeDef *GPIOx)
// 描述: 初始化IO口.
// 参数: GPIOx: 结构参数,请参考timer.h里的定义.
// 返回: 成功返回 SUCCESS, 错误返回 FAIL.
// 版本: V1.0, 2012-10-22
//========================================================================
uint8_t	GPIO_Inilize(uint8_t GPIO, GPIO_InitTypeDef *GPIOx)
{
	if(GPIO > GPIO_P7)				return FAIL;	//错误
	if(GPIOx->Mode > GPIO_OUT_PP)	return FAIL;	//错误
	if(GPIO == GPIO_P0)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P0M1 &= ~GPIOx->Pin,	P0M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P0M1 |=  GPIOx->Pin,	P0M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P0M1 |=  GPIOx->Pin,	P0M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P0M1 &= ~GPIOx->Pin,	P0M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P1)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P1M1 &= ~GPIOx->Pin,	P1M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P1M1 |=  GPIOx->Pin,	P1M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P1M1 |=  GPIOx->Pin,	P1M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P1M1 &= ~GPIOx->Pin,	P1M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P2)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P2M1 &= ~GPIOx->Pin,	P2M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P2M1 |=  GPIOx->Pin,	P2M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P2M1 |=  GPIOx->Pin,	P2M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P2M1 &= ~GPIOx->Pin,	P2M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P3)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P3M1 &= ~GPIOx->Pin,	P3M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P3M1 |=  GPIOx->Pin,	P3M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P3M1 |=  GPIOx->Pin,	P3M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P3M1 &= ~GPIOx->Pin,	P3M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P4)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P4M1 &= ~GPIOx->Pin,	P4M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P4M1 |=  GPIOx->Pin,	P4M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P4M1 |=  GPIOx->Pin,	P4M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P4M1 &= ~GPIOx->Pin,	P4M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P5)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P5M1 &= ~GPIOx->Pin,	P5M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P5M1 |=  GPIOx->Pin,	P5M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P5M1 |=  GPIOx->Pin,	P5M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P5M1 &= ~GPIOx->Pin,	P5M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P6)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P6M1 &= ~GPIOx->Pin,	P6M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P6M1 |=  GPIOx->Pin,	P6M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P6M1 |=  GPIOx->Pin,	P6M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P6M1 &= ~GPIOx->Pin,	P6M0 |=  GPIOx->Pin;	 //推挽输出
	}
	if(GPIO == GPIO_P7)
	{
		if(GPIOx->Mode == GPIO_PullUp)		P7M1 &= ~GPIOx->Pin,	P7M0 &= ~GPIOx->Pin;	 //上拉准双向口
		if(GPIOx->Mode == GPIO_HighZ)			P7M1 |=  GPIOx->Pin,	P7M0 &= ~GPIOx->Pin;	 //浮空输入
		if(GPIOx->Mode == GPIO_OUT_OD)		P7M1 |=  GPIOx->Pin,	P7M0 |=  GPIOx->Pin;	 //开漏输出
		if(GPIOx->Mode == GPIO_OUT_PP)		P7M1 &= ~GPIOx->Pin,	P7M0 |=  GPIOx->Pin;	 //推挽输出
	}
	return SUCCESS;	//成功
}
#define	EXT_MODE_Fall		1	//下降沿中断
#define	EXT_MODE_Rise		2	//上升沿中断
#define	EXT_MODE_Low		3	//低电平中断
#define	EXT_MODE_High		4	//高电平中断


uint8_t	GPIOExti_Inilize(uint8_t GPIO, GPIO_ExtiTypeDef *INTx)
{
	if(GPIO > GPIO_P7)				return FAIL;	//错误
	if((INTx->EXTI_Mode > EXT_MODE_Low) ||(INTx->EXTI_Mode == EXT_MODE_RiseFall))	return FAIL;	//错误
	if(GPIO == GPIO_P0)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P0IM1 &= ~INTx->PIN;	P0IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P0IM1 &= ~INTx->PIN;	P0IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P0IM1 |= INTx->PIN;	P0IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P0IM1 |= INTx->PIN;	P0IM0 |= INTx->PIN;		//高电平中断
		if(INTx->Exti_Enable == ENABLE)		P0INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P0INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P1)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P1IM1 &= ~INTx->PIN;	P1IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P1IM1 &= ~INTx->PIN;	P1IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P1IM1 |= INTx->PIN;	P1IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P1IM1 |= INTx->PIN;	P1IM0 |= INTx->PIN;		//高电平中断
		if(INTx->Exti_Enable == ENABLE)		P1INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P1INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P2)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P2IM1 &= ~INTx->PIN;	P2IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P2IM1 &= ~INTx->PIN;	P2IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P2IM1 |= INTx->PIN;	P2IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P2IM1 |= INTx->PIN;	P2IM0 |= INTx->PIN;		//高电平中断	
		if(INTx->Exti_Enable == ENABLE)		P2INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P2INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P3)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P3IM1 &= ~INTx->PIN;	P3IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P3IM1 &= ~INTx->PIN;	P3IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P3IM1 |= INTx->PIN;	P3IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P3IM1 |= INTx->PIN;	P3IM0 |= INTx->PIN;		//高电平中断	
		if(INTx->Exti_Enable == ENABLE)		P3INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P3INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P4)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P4IM1 &= ~INTx->PIN;	P4IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P4IM1 &= ~INTx->PIN;	P4IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P4IM1 |= INTx->PIN;	P4IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P4IM1 |= INTx->PIN;	P4IM0 |= INTx->PIN;		//高电平中断	
		if(INTx->Exti_Enable == ENABLE)		P4INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P4INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P5)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P5IM1 &= ~INTx->PIN;	P5IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P5IM1 &= ~INTx->PIN;	P5IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P5IM1 |= INTx->PIN;	P5IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P5IM1 |= INTx->PIN;	P5IM0 |= INTx->PIN;		//高电平中断
		if(INTx->Exti_Enable == ENABLE)		P5INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P5INTE &= ~INTx->PIN;		
	}
	if(GPIO == GPIO_P6)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P6IM1 &= ~INTx->PIN;	P6IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P6IM1 &= ~INTx->PIN;	P6IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P6IM1 |= INTx->PIN;	P6IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P6IM1 |= INTx->PIN;	P6IM0 |= INTx->PIN;		//高电平中断
		if(INTx->Exti_Enable == ENABLE)		P6INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P6INTE &= ~INTx->PIN;
	}
	if(GPIO == GPIO_P7)
	{
		if(INTx->EXTI_Mode == EXT_MODE_Fall)  P7IM1 &= ~INTx->PIN;	P7IM0 &= ~INTx->PIN;	//下降沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Rise)  P7IM1 &= ~INTx->PIN;	P7IM0 |= INTx->PIN;		//上升沿中断
		if(INTx->EXTI_Mode == EXT_MODE_Low)  P7IM1 |= INTx->PIN;	P7IM0 &= ~INTx->PIN;	//低电平中断
		if(INTx->EXTI_Mode == EXT_MODE_High)  P7IM1 |= INTx->PIN;	P7IM0 |= INTx->PIN;		//高电平中断	
		if(INTx->Exti_Enable == ENABLE)		P7INTE |= INTx->PIN;
		if(INTx->Exti_Enable == DISABLE)		P7INTE &= ~INTx->PIN;
	}
	
	return SUCCESS;	//成功
}
